#include "stm.h"

// HACK HACK HACK

stmCore	global_stmCore;

// HACK HACK HACK

#if defined(BOOST_HAS_WINTHREADS)
extern	"C"	{
#include	<windows.h>
}
#endif

int
stmCore::getthreadId()	{
#if	defined(BOOST_HAS_WINTHREADS)
	return((int)GetCurrentThreadId());
#elif	defined(BOOST_HAS_PTHREADS)
	return((int)pthread_self());
#elif	defined(BOOST_HAS_MPTASKS)
	// I don't know
	return(-1);
#endif
	}

stmCore::stmCore(void) {
	readFaults = writeFaults = writeReadCommitFaults = commits = 0;
}

stmCore::~stmCore(void) {

}


// this is an unfortunate side effect of trying to use boost.  Basically we
// learn about threads as we go along.  The safest way to use stmCore is to
// "register" all threads with it prior to commencing any transactional
// work.  The way you do this is just call getstmThread_handleCreate().
//
// But if you don't do this, the system will generally be ok...

stmThread	*
stmCore::__getstmThread(){
	int	threadId = getthreadId();
/*
	map<int, stmThread *>::iterator	threadIterator;

	threadIterator = threadMap.find(threadId);
	if ( threadIterator != threadMap.end() )
		return(threadIterator->second);
	// attempt to register the thread.
	// in rare cases can deadlock*/

	stmThread	*theThread;
	if(theThread = threadMap[threadId])
		return(theThread);
	
	return(getstmThread_handleCreate());
	}

stmThread	*
stmCore::getstmThread_handleCreate(){
	boost::mutex::scoped_lock	lock(this->coreLock);
	stmThread	*theThread;
	int	threadId = getthreadId();

	theThread = threadMap[threadId];
	if ( !theThread ) {
		theThread = new stmThread(threadId);
		threadMap[theThread->thethreadId] = theThread;
 		}
	else
		theThread = threadMap[threadId];

	return(theThread);
	}

stmThread		*
stmCore::getstmThread() {
	return(__getstmThread());
	}


void
stmCore::ReadFault(genericStmObject *) {
	++readFaults;
	++__getstmThread()->readFaults;
	//printf("ReadFault! %d\n", getthreadId());
	retryTransaction();
	}


void
stmCore::WriteFault(genericStmObject *){
	++writeFaults;
	++__getstmThread()->writeFaults;
	//printf("WriteFault!\n");
	retryTransaction();
	}



bool
stmCore::__searchForReadConflict(genericStmObject *o, stmThread *writingThread){
	map<int, stmThread *>::iterator	threadIterator;

	for(threadIterator = threadMap.begin() ; threadIterator != threadMap.end() ; threadIterator++) {
		stmThread	*readingThread = threadIterator->second;
		if ( readingThread == writingThread )	continue;

		if ( readingThread->nestLevel == 0 )	continue;

		if ( readingThread->theReadSet.find(o) != readingThread->theReadSet.end() )	return ( false );	// fail
		}
	return ( true );
	}

stmThread	*
stmCore::addToReadSet(genericStmObject *o){
	stmThread 	*theThread = __getstmThread();
	// not in a transaction
	if ( theThread->nestLevel == 0 )	return(NULL);

	boost::mutex::scoped_lock	lock(theThread->threadLock);
	theThread->theReadSet.insert(o);
	return(theThread);
	}



stmThread	*
stmCore::addToWriteSet(genericStmObject *o){
	stmThread 	*theThread = __getstmThread();
	// not in a transaction

	if ( theThread->nestLevel == 0 )	return(NULL);

	boost::mutex::scoped_lock	lock(theThread->threadLock);

	theThread->theWriteSet.insert(o);
	return(theThread);
	}


int
stmCore::beginTransaction(char	*debugInformation) {
	// step 1: find out who we are
	stmThread	*theThread = getstmThread_handleCreate();
	++theThread->nestLevel;
	return(theThread->nestLevel);
	}


int
stmCore::handlestmRestart(int	Exception)
	{
	stmThread	*theThread = __getstmThread();
	//printf("caught exception! %d\n", theThread->thethreadId);

	--theThread->nestLevel;
	if(theThread->nestLevel != 0 ) {
		throw stmRestart(Exception);	// unwind some more
	}
	if ( Exception == stmRestart::Retry ) {
		boost::mutex::scoped_lock	lock(this->coreLock);
		// oh crap!  It's a rollback
		__cleanupFailedTransaction(theThread);
		//printf("restarting transaction... hopefully\n");
		return(0);	// restart transaction
		}
	if ( Exception == stmRestart::UserRetry ) {
		boost::mutex::scoped_lock	lock(this->coreLock);
		// this is a special user-level retry.  What happened is the use
		// actually stuck retry_transaction in the code and the statement
		// was reached.  The smart way to handle this is to save the
		// read/write set, and then not schedule this thread until
		// something in that set changes.
		// its really no fun to do this though...
		// so we do something cheezy...
		__cleanupFailedTransaction(theThread);
		boost::thread::yield();
		return(0);	// restart transaction
		}
	if ( Exception == stmRestart::Abort ) {
		boost::mutex::scoped_lock	lock(this->coreLock);		// use called abort, I think.
		__cleanupFailedTransaction(theThread);
		return(2); // end the transaction
		}
	// ut oh
	printf("stmCore unknown exception type: %d\n", Exception);
	assert(0);
	return(1);
	}

int
stmCore::abortTransaction(){
	stmThread	*theThread = __getstmThread();
	//printf("abort %x\n", this);
	throw stmRestart(stmRestart::Abort);
	}

int
stmCore::retryTransaction(){
	stmThread	*theThread = __getstmThread();
	//printf("retry %x\n", this);
	throw stmRestart(stmRestart::Retry);
	}

int
stmCore::userRetryTransaction(){
stmThread	*theThread = __getstmThread();
	//printf("retry %x\n", this);
	throw stmRestart(stmRestart::UserRetry);
	}

int
stmCore::endTransaction(){
	boost::mutex::scoped_lock	lock(this->coreLock);
	// if we get here, then the transaction might be commitable if nestLevel-- == 0
	stmThread 	*theThread = __getstmThread();
	bool	ret;

	assert(theThread->nestLevel > 0);
			
	--theThread->nestLevel;
	if ( theThread->nestLevel == 0 ) {	// oh crap, it's going to try and commit!
		set<genericStmObject *>::iterator	objectIterator;
		// this first for loop can be optimzed away.
		for(objectIterator = theThread->theReadSet.begin() ;
			objectIterator != theThread->theReadSet.end() ;
			objectIterator++)
			if ( ! (*objectIterator)->read_commit(theThread) ) {
				__cleanupFailedTransaction(theThread);
				++writeReadCommitFaults;
				return(false);
				}
		// this second for loop looks for other threads that read
		// our data that we wrote.  If it finds them, then we rollback
		// our transaction, because they are using pre-our-transaction data
		// and still have hope of terminating/commiting.
		for(objectIterator = theThread->theWriteSet.begin() ;
			objectIterator != theThread->theWriteSet.end() ;
			objectIterator++) {
			if ( ! __searchForReadConflict( *objectIterator, theThread ) ) {
				__cleanupFailedTransaction(theThread);
				++writeReadCommitFaults;
				return(false);
				}
			}
		// this final loop commits our write set
		for(objectIterator = theThread->theWriteSet.begin() ;
			objectIterator != theThread->theWriteSet.end() ;
			objectIterator++) {
			ret = (*objectIterator)->write_commit(theThread);
			assert(ret);
		}
		theThread->theWriteSet.clear();
		theThread->theReadSet.clear();
		++theThread->commits;
		++commits;
		}
	return(true);
	}


void
stmCore::__cleanupFailedTransaction(stmThread	*theThread){
	set<genericStmObject *>::iterator	objectIterator;
	for(objectIterator = theThread->theReadSet.begin() ;
		objectIterator != theThread->theReadSet.end() ;
		objectIterator++)
		(*objectIterator)->read_rollback(theThread);

	for(objectIterator = theThread->theWriteSet.begin() ;
		objectIterator != theThread->theWriteSet.end() ;
		objectIterator++)
		(*objectIterator)->write_rollback(theThread);
	theThread->theWriteSet.clear();
	theThread->theReadSet.clear();
	//theThread->nestLevel = 0;
	}


#define	dumpStat(nnn)	printf("%30s : %d\n", #nnn, nnn)

void
stmCore::printStatistics(){
	dumpStat(readFaults);
	dumpStat(writeFaults);
	dumpStat(writeReadCommitFaults);
	dumpStat(commits);
	}
